//
//  attractor.c
//  Experiment
//
//  Created by Andreas Giskeødegård on 4/3/13.
//  Copyright (c) 2013 Andreas Giskeødegård. All rights reserved.
//

#include <stdio.h>
#include "attractor_checking.h"
#include "file_helper.h"

static linked_buffer ** archive = NULL;
static linked_buffer * first_buffer = NULL;
static int number_of_hd_buffers;

void init_hd_buffers(int number_of_buffers, int size){
    number_of_hd_buffers = number_of_buffers;
    
    archive = (linked_buffer **) malloc(sizeof(linked_buffer*)*number_of_buffers);
    
    for (int i = 0; i < number_of_buffers; i++){
        archive[i] = malloc(sizeof(linked_buffer));
        archive[i]->buffer = calloc(size, sizeof(char));
        archive[i]->next = NULL;
    }
    first_buffer = archive[0];
    for (int i = 0; i < number_of_buffers; i++){
        if ((i+1) < number_of_buffers){
            archive[i]->next = archive[i+1];
        }
    }
}

void free_hd_buffers(){
    linked_buffer * a_buffer = NULL;
    for (int i = 0; i < number_of_hd_buffers; i++){
        a_buffer = first_buffer->next;
        free(first_buffer->buffer);
        free(first_buffer);
        first_buffer = a_buffer;
    }
    free(archive);
    first_buffer = NULL;
}


int get_number_of_hd_buffers(){
    return number_of_hd_buffers;
}

linked_buffer *  get_fist_hd_buffer(){
    return first_buffer;
}

