//
//  bucket_sort.c
//  Experiment
//
//  Created by Andreas Giskeødegård on 4/15/13.
//  Copyright (c) 2013 Andreas Giskeødegård. All rights reserved.
//

#include <stdio.h>
#include <math.h>
#include "bucket_sort.h"

#define BUCKET_SIZE 10


static bucket ** buckets;
static int number_of_buckets;

content * alloc_content(long ds_step){
    content * t = malloc(sizeof(content));
    t->step = ds_step;
    t->nxt = NULL;
    return t;
}

void init_butckets_(int buckets_n){
    number_of_buckets = buckets_n;
    
    buckets = calloc(buckets_n, sizeof(bucket*));
    for (int i = 0; i < buckets_n; i++ ){
        buckets[i] = calloc(1, sizeof(bucket));
        buckets[i]->contents = NULL;
    }
    
}
void free_buckets(){
    for (int i = 0; i < number_of_buckets; i++){
        content * t = buckets[i]->contents;
        content * g = NULL;
        while(t != NULL){
            g = t->nxt;
            free(t);
            t = g;
        }

        free(buckets[i]);
    }
    free(buckets);
    buckets = 0;
    number_of_buckets = 0;
}

int index_from_key(uint16_t key){
    return fmod(key, number_of_buckets);
}

bucket * get_relevant_bucket(uint16_t key){
    int index = index_from_key(key);
    return buckets[index];
}



void add_to_bucket(uint16_t key, long ds_step){

    int index = index_from_key(key);
    bucket * b = buckets[index];
    content * cur = b->contents;
    content * nxt = NULL;
    if (cur != NULL){
        
        
        do{
            nxt = cur->nxt;
            if (nxt != NULL && nxt->step < ds_step){
                cur = nxt;
                nxt = cur->nxt;
            }
            else if (cur->step < ds_step && nxt == NULL){
//                last element
                cur->nxt = alloc_content(ds_step);
                cur->nxt->nxt = nxt;
                break;
            } else if (cur->step < ds_step &&  ds_step <= nxt->step){
                //between
                cur->nxt = alloc_content(ds_step);
                cur->nxt->nxt = nxt;
                break;
            } else{
                //before
                b->contents = alloc_content(ds_step);
                b->contents->nxt = cur;
                break;

            }
        }while (1);
 
    }else{
        b->contents = alloc_content(ds_step);
    }
}