//
//  elitism.c
//  Experiment
//
//  Created by Andreas Giskeødegård on 4/29/13.
//  Copyright (c) 2013 Andreas Giskeødegård. All rights reserved.
//

#include <stdio.h>
#include "elitism.h"
#include "cellular_automata.h"
#include "genotype.h"

//Extern get
extern population * pop;

/**
 * ELITISM
 */

checkable * get_elites(int amount){
    checkable * elite = calloc(amount, sizeof(checkable));
    for (int i = 0; i < pop->size; i++){
        checkable check = {.value=pop->fitness[i].attractor_fitness, .index=i };
        for (int j = 0; j < amount; j++){
            if (elite[j].value < check.value){
                checkable tmp = elite[j];
                elite[j] = check;
                check = tmp;
            }
        }
    }
    return elite;
}
void perform_elitism(int number_of_elites){
    if (number_of_elites == 0){
        return;
    }
    
    checkable * elite = get_elites(number_of_elites);
    for (int i = 0; i < number_of_elites; i++){
        automata * e_ca = pop->cur[elite[i].index];
        pop->new_pop[i] = init_automata(e_ca->val);
        pop->new_pop[i]->gtype = init_empty_genotype(e_ca->gtype->size);
        copy_gtype(pop->new_pop[i]->gtype, e_ca->gtype);
    }
    free(elite);
}