//
//  genotype.h
//  Experiment
//
//  Created by Andreas Giskeødegård on 3/26/13.
//  Copyright (c) 2013 Andreas Giskeødegård. All rights reserved.
//

#ifndef Experiment_genotype_h
#define Experiment_genotype_h
#include "structs.h"

/**
 * FREEING
 */
void free_genotype(list * gtype);

/**
 * GENOTYPE_INITIS
 */
list * init_empty_genotype(int size);
list * init_full_genotype(automata * ca, int next);
list * init_restircted_genotype_empty_genes(int genes_n);
list * init_restricted_genotype (int number_of_genes, int number_of_states, int next_value);

/**
 * CALCULATION
 */

char get_next_state_apply_rules_to_gene(list * gtype, uint32_t gene, uint32_t mask, int states);

/**
 * UTILITY
 */
void copy_gtype(list * to, list *from);
list * grow_genotype(list * l);
list * grow_gene_copy_random(list * l);

/**
 * IO
 */
void save_genotype_to_disk(list * gtype, int states);

//testing types
list * wolfram_gtype(automata * ca, int8_t number);
list * growing_north_2d(automata * ca);
list * growing_south_2d(automata * ca);
list * growing_east_2d(automata * ca);
list * growing_west_2d(automata * ca);
list * growing_diagonal_2d(automata * ca);

#endif
