//
//  main.c
//  Experiment
//
//  Created by Andreas Giskeødegård on 3/26/13.
//  Copyright (c) 2013 Andreas Giskeødegård. All rights reserved.
//

#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include "experimet.h"
#include "testing.h"
#include "old_data_handling.h"
#include "gplotilizer.h"
#include "mersenne_twister.h"
#include "program_setup.h"

unsigned long randomseed(){
    size_t size = sizeof(unsigned long);
    unsigned long value = 0;
    FILE * f = fopen("/dev/random", "r");
    fread(&value, size, 1, f);
    fclose(f);
    return value;
}

void do_handle(){
    printf("start the handling\n");
    handle_it();
}

void do_comp(){
    /*
    printf("start the comparison\n");
    create_comparison_lin();
    */
    
    printf("start the fitnessweigting configuring\n");
    
    int attractor = 0;
    printf("input attractor :");
    
    scanf(" %d", &attractor);
    printf("input wanted attractor :");
    if (attractor != 40 || attractor != 100){
        check_fittness_weighting(attractor);
    }else {
        printf("Not acceptable attractor length, choose 100 or 40\n");
    }
     
    
    //config_mutation_pr_chrom();
}

void do_timeing(){
    printf("start the longrun\n");
    printf("input gensteps :");
    int gesteps = 0;
    double activation = 0.0, mutation = 0.0;
    scanf(" %d", &gesteps);
    printf("input mutation :");
    scanf("%lf", &mutation);
    printf("input activation weight :");
    scanf("%lf\r", &activation);
    long_run(gesteps, mutation, activation);
}

void do_run_exp(){
    char buffer[256] = {0};
    printf("muation_pr_individual? (Y/N)\n");
    scanf("%s", buffer);
    if (strcmp(buffer, "Y") == 0){
        test_for_elitism(1);
    }else if (strcmp(buffer, "N") == 0){
        test_for_elitism(0);
    }
    /*
    printf("grow or rest?\n");
    scanf("%s", buffer);
    if (strcmp(buffer, "grow") == 0){
        printf("running grow\n");
        growing_4x4_3state_experiment_short();
        
    }else if (strcmp(buffer, "rest") == 0){
        printf("running rest\n");
        rest_4x4_3state_experiment_short();
    }
*/
}

void do_get_gen_leng(){
    int attractor = 0;
    printf("input attractorlength:");
    scanf("%d", &attractor);
    growing_4x4_single_run_for_gen_length(attractor);
}




int main(int argc, const char * argv[])
{
    
    unsigned long init[4] = {0};
    int length=4;
    for (int i = 0; i < length; i++){
        init[i] = randomseed();
    }
    init_by_array(init, length);    

    //handle_it();
    //test_for_elitism();
    char buffer[256] = {0};
    printf("what do ?\n");
    scanf("%s", buffer);
    
    char *valid_inputs[5] = {"handle", "comp", "timeing", "run_exp", "get_gen_leng"};
        
    printf("argument %s\n", buffer);
    if (strcmp(buffer, "handle") == 0){
        do_handle();
    }else if (strcmp(buffer, "comp") == 0){
        do_comp();
    }else if (strcmp(buffer, "timeing") == 0){
        do_timeing();
    }else if (strcmp(buffer, "run_exp") == 0){
        do_run_exp();
    }else if (strcmp(buffer, "get_gen_leng") == 0){
        do_get_gen_leng();
    }else if (strcmp(buffer, "main_exp") == 0){
        printf("what part?\n");
        int part;
        scanf("%d",&part);
        switch (part) {
            case 1:
                main_experiment_part1();
                break;
                
            case 2:
                main_experiment_part2();
                break;
                
            case 3:
                main_experiment_part3();
                break;
                
            case 4:
                main_experiment_part4();
                break;
            default:
                break;
        }
    }else if (strcmp(buffer, "rework") == 0){
        printf("plotting 1 = handeling\nplotting 2 = redevelop\nplotting 3 = rulegraphs\nplotting 4 = individual genome growth\n");
        int part;
        scanf("%d",&part);
        switch (part) {
            case 1:
                handle_it();
                break;
                
            case 2:
                redevelop_in_handle();
                break;
                
            case 3:
                rule_graphs_for_successful();
                break;
            case 4:
                individual_plots();
                break;
            default:
                break;
        }
    
    
    } else {
        printf("'%s' is unknown input, try one of these:\n", argv[1]);
        for (int i = 0; i<5; i++){
            printf("%s\n", valid_inputs[i]);
        }
    }

    return 0;
}


